using System;
using System.Configuration;

namespace ADDDF.Infrastructure.Configuration
{
    public sealed class RepositoryAssemblyCollection : ConfigurationElementCollection
    {
        protected override ConfigurationElement CreateNewElement()
        {
            return new RepositoryAssemblyElement();
        }

        protected override object GetElementKey(ConfigurationElement element)
        {
            return ((RepositoryAssemblyElement)element).Name;
        }

        public override ConfigurationElementCollectionType CollectionType
        {
            get { return ConfigurationElementCollectionType.BasicMap; }
        }

        protected override string ElementName
        {
            get { return RepositoryMappingConstants.RepositoryAssemblyElementName; }
        }

        public RepositoryAssemblyElement this[int index]
        {
            get { return (RepositoryAssemblyElement)this.BaseGet(index); }
            set
            {
                if (this.BaseGet(index) != null)
                {
                    this.BaseRemoveAt(index);
                }
                this.BaseAdd(index, value);
            }
        }

        public new RepositoryAssemblyElement this[string assemblyName]
        {
            get { return (RepositoryAssemblyElement)this.BaseGet(assemblyName); }
        }

        public bool ContainsKey(string keyName)
        {
            bool result = false;
            object[] keys = this.BaseGetAllKeys();
            foreach (object key in keys)
            {
                if ((string)key == keyName)
                {
                    result = true;
                    break;

                }
            }
            return result;
        }
    }
}
